package io.xjar;

import java.util.regex.Pattern;
import org.apache.commons.compress.archivers.jar.JarArchiveEntry;

public abstract class XAntEntryFilter implements XEntryFilter<JarArchiveEntry>
{
    private static final String[] SYMBOLS;
    private final Pattern pattern;
    
    protected XAntEntryFilter(final String ant) {
        String regex = ant;
        for (final String symbol : XAntEntryFilter.SYMBOLS) {
            regex = regex.replace(symbol, '\\' + symbol);
        }
        for (regex = regex.replace("?", ".{1}"), regex = regex.replace("**/", "(.{0,}?/){0,}?"), regex = regex.replace("**", ".{0,}?"), regex = regex.replace("*", "[^/]{0,}?"); regex.startsWith("/"); regex = regex.substring(1)) {}
        while (regex.endsWith("/")) {
            regex = regex.substring(0, regex.length() - 1);
        }
        this.pattern = Pattern.compile(regex);
    }
    
    protected boolean matches(final String text) {
        return this.pattern.matcher(text).matches();
    }
    
    static {
        SYMBOLS = new String[] { "\\", "$", "(", ")", "+", ".", "[", "]", "^", "{", "}", "|" };
    }
}
